%%% Monte Carlo Dynamic Classifier tool - MCDC tool
% http://www.ismvideo.org/NDE0UP/MCDCtool/en/index.html

% Copyright (C) 2014-2015 Gareth W. Peters, Tomoko Matsui, Francois Septier, and Akira Tamamori

% This program is free software; you can redistribute it and/or modify it under the terms
% of the GNU General Public License as published by the Free Software Foundation; either
% version 2 of the License, or (at your option) any later version.

% This program is distributed in the hope that it will be useful, but WITHOUT ANY
% WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE.  See the GNU General Public License for more details.

% You should have received a copy of the GNU General Public License along with this
% program; if not, see <http://www.gnu.org/licenses/>.

%
% ContinuousUnivariateDistribution.m
%
classdef (Abstract) ContinuousUnivariateDistribution < Distribution

  properties (GetAccess = protected, SetAccess = private)
    dist
    dim
  end

  methods (Access = protected)

    function this = ContinuousUnivariateDistribution(dist, dim)
      this.dist = dist;
      this.dim = dim;
    end

  end

  methods (Access = public)

    function result = Pdf(this, x)
      % x : data sequence of size N * dim
      result = prod(pdf(this.dist, x), 2);
    end

    function result = Random(this, n)
      if nargin < 2
        n = 1;
      end
      result = random(this.dist, n, this.dim);
    end

  end

end
