%%% Monte Carlo Dynamic Classifier tool - MCDC tool
% http://www.ismvideo.org/NDE0UP/MCDCtool/en/index.html

% Copyright (C) 2014-2015 Gareth W. Peters, Tomoko Matsui, Francois Septier, and Akira Tamamori

% This program is free software; you can redistribute it and/or modify it under the terms
% of the GNU General Public License as published by the Free Software Foundation; either
% version 2 of the License, or (at your option) any later version.

% This program is distributed in the hope that it will be useful, but WITHOUT ANY
% WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE.  See the GNU General Public License for more details.

% You should have received a copy of the GNU General Public License along with this
% program; if not, see <http://www.gnu.org/licenses/>.

%
% ExponentialDistribution.m
%
classdef ExponentialDistribution < ContinuousUnivariateDistribution

  properties (SetAccess = private)
    Mu
  end

  methods (Access = public)

    function this = ExponentialDistribution(mu, dim)
      if nargin < 2
        dim = 1;
      end
      this = this@ContinuousUnivariateDistribution( ...
          makedist('Exponential', 'mu', mu), ...
          dim);
      this.Mu = mu;
    end

    function result = LogPdf(this, x)
      mu = this.Mu;
      result = -sum(x, 2) / mu - this.dim * log(mu);
    end

  end

end
