%%% Monte Carlo Dynamic Classifier tool - MCDC tool
% http://www.ismvideo.org/NDE0UP/MCDCtool/en/index.html
%
% Copyright (C) 2014-2015 Gareth W. Peters, Tomoko Matsui, Francois Septier, and Akira Tamamori
%
% This program is free software; you can redistribute it and/or modify it under the terms
% of the GNU General Public License as published by the Free Software Foundation; either
% version 2 of the License, or (at your option) any later version.
%
% This program is distributed in the hope that it will be useful, but WITHOUT ANY
% WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE.  See the GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License along with this
% program; if not, see <http://www.gnu.org/licenses/>.

classdef IterationStrategyProbabilistic < IterationStrategy

  properties (Access = public)
    u0
  end

  properties (Access = private)
    default
    mhGibbs
  end

  methods (Access = public)

    function this = IterationStrategyProbabilistic(u0)
      this.u0 = u0;
      this.default = IterationStrategyDefault();
      this.mhGibbs = IterationStrategyMHGibbs();
    end

    function SetUp(this, varargin)
      this.default.SetUp(varargin{:});
      this.mhGibbs.SetUp(varargin{:});
    end

    function ProcessIteration(this, varargin)

      j = varargin{1};
      aspect = varargin{4};

      u = rand();
      if j == 1 || u < this.u0
        aspect.Log('  u = %f, do PMCMC', u);
        this.default.ProcessIteration(varargin{:});
      else
        aspect.Log('  u = %f, do MH-Gibbs', u);
        this.mhGibbs.ProcessIteration(varargin{:});
      end

    end

  end

end
