%%% Monte Carlo Dynamic Classifier tool - MCDC tool
% http://www.ismvideo.org/NDE0UP/MCDCtool/en/index.html

% Copyright (C) 2014 Gareth W. Peters, Tomoko Matsui, Francois Septier, and Akira Tamamori

% This program is free software; you can redistribute it and/or modify it under the terms
% of the GNU General Public License as published by the Free Software Foundation; either
% version 2 of the License, or (at your option) any later version.

% This program is distributed in the hope that it will be useful, but WITHOUT ANY
% WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE.  See the GNU General Public License for more details.

% You should have received a copy of the GNU General Public License along with this
% program; if not, see <http://www.gnu.org/licenses/>.

%
% SimpleSpline.m
%
% spline を用いた 1 次元 spline 補間
%   xGrids: グリッドの次元毎の値の配列を、セル配列で与える
%   yArray: 各グリッド点における値を、多次元配列で与える
%   result: 補間された関数
%
% xGrids が 1 次元であることを前提とする
%
function result = SimpleSpline(xGrids, yArray)
  pp = spline(xGrids{1}, yArray');
  result = @(x) ppval(pp, x);
end
