%%% Monte Carlo Dynamic Classifier tool - MCDC tool
% http://www.ismvideo.org/NDE0UP/MCDCtool/en/index.html

% Copyright (C) 2014-2015 Gareth W. Peters, Tomoko Matsui, Francois Septier, and Akira Tamamori

% This program is free software; you can redistribute it and/or modify it under the terms
% of the GNU General Public License as published by the Free Software Foundation; either
% version 2 of the License, or (at your option) any later version.

% This program is distributed in the hope that it will be useful, but WITHOUT ANY
% WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE.  See the GNU General Public License for more details.

% You should have received a copy of the GNU General Public License along with this
% program; if not, see <http://www.gnu.org/licenses/>.

Times = 950:1000;

Iters = [1 10 100 1000 10000];
Iter = Iters(end);

load('logs/KitagawaModelPMCMC2_Data.mat');

Graphs.YE('plots/KitagawaModelPMCMC2_YE', ['logs/KitagawaModelPMCMC2_' num2str(Iter) '.mat'], Iters);
Graphs.XE('plots/KitagawaModelPMCMC2_XE', ['logs/KitagawaModelPMCMC2_' num2str(Iter) '.mat'], Iters);
Graphs.YEMean('plots/KitagawaModelPMCMC2_YEMean', ['logs/KitagawaModelPMCMC2_' num2str(Iter) '.mat']);
Graphs.XEMean('plots/KitagawaModelPMCMC2_XEMean', ['logs/KitagawaModelPMCMC2_' num2str(Iter) '.mat']);

Graphs.YE(['plots/KitagawaModelPMCMC2_YE_from' num2str(Times(1))], ['logs/KitagawaModelPMCMC2_' num2str(Iter) '.mat'], Iters, Times);
Graphs.XE(['plots/KitagawaModelPMCMC2_XE_from' num2str(Times(1))], ['logs/KitagawaModelPMCMC2_' num2str(Iter) '.mat'], Iters, Times);
Graphs.YEMean(['plots/KitagawaModelPMCMC2_YEMean_from' num2str(Times(1))], ['logs/KitagawaModelPMCMC2_' num2str(Iter) '.mat'], Times);
Graphs.XEMean(['plots/KitagawaModelPMCMC2_XEMean_from' num2str(Times(1))], ['logs/KitagawaModelPMCMC2_' num2str(Iter) '.mat'], Times);

Graphs.Loglik('plots/KitagawaModelPMCMC2_Loglik', ['logs/KitagawaModelPMCMC2_' num2str(Iter) '.mat']);

quit;
