%%% Monte Carlo Dynamic Classifier tool - MCDC tool
% http://www.ismvideo.org/NDE0UP/MCDCtool/en/index.html

% Copyright (C) 2014-2015 Gareth W. Peters, Tomoko Matsui, Francois Septier, and Akira Tamamori

% This program is free software; you can redistribute it and/or modify it under the terms
% of the GNU General Public License as published by the Free Software Foundation; either
% version 2 of the License, or (at your option) any later version.

% This program is distributed in the hope that it will be useful, but WITHOUT ANY
% WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE.  See the GNU General Public License for more details.

% You should have received a copy of the GNU General Public License along with this
% program; if not, see <http://www.gnu.org/licenses/>.

%
% LinearStateSpaceModelPMCMC2Estimation.m
%

rng('default');

%
% Generate state and observation time series from Linear state space model
%

T    = 100;
k1   = 0.1;
k2   = 0.1;
mass = 1.0;
q    = 0.1;
r    = 0.1;
dt   = 0.2;

[x, y, F, H] = LinearStateSpaceModel(T, k1, k2, mass, q, r, dt);

% Set the esimation output file to modelFile
modelFile = 'logs/LinearStateSpaceModelPMCMC2_1000.mat';
outputFile = 'logs/LinearStateSpaceModelPMCMC2Test_regression.mat';

aspect = Aspect();
aspect.LogFileName = 'logs/LinearStateSpaceModelPMCMC2Test_regression.log';
aspect.Log('Testing LinearStateSpaceModel');

xaux = [];
u = zeros(size(x));
N = 50;
T = 1;
[result, F, G, ypred] = MCDCRegression( ...
  u(1:end-T, :)', ...
  y(1:end-T, :)', ...
  N, ...
  u(end-T+1:end, :)', ...
  T, ...
  modelFile ...
);

save(outputFile);
