classdef ModelFunctions2Test < matlab.unittest.TestCase

  methods (Test)

    function testModelFunctions2_Grid1d(this)
      gridData.Grids = { 1:10 };
      eqnVals = reshape(1:10, [1 10]);
      funcs = ModelFunctions2(@GenericSpline, gridData, eqnVals);
      this.verifyEqual(size(funcs), [1 1]);
      this.verifyTrue(isscalar(funcs{1}([3])));
    end

    function testModelFunctions2_Grid2d(this)
      gridData.Grids = { 1:10, 1:20 };
      eqnVals = reshape(1:200, [1 10 20]);
      funcs = ModelFunctions2(@GenericSpline, gridData, eqnVals);
      this.verifyEqual(size(funcs), [1 1]);
      this.verifyTrue(isscalar(funcs{1}([3; 8])));
    end

    function testModelFunctions2_Grid3d(this)
      gridData.Grids = { 1:10, 1:20, 1:30 };
      eqnVals = reshape(1:6000, [1 10 20 30]);
      funcs = ModelFunctions2(@GenericSpline, gridData, eqnVals);
      this.verifyEqual(size(funcs), [1 1]);
      this.verifyTrue(isscalar(funcs{1}([3; 8; 5])));
    end

    function testModelFunctions2_Values2d(this)
      gridData.Grids = { 1:10 };
      eqnVals = reshape(1:20, [2 10]);
      funcs = ModelFunctions2(@GenericSpline, gridData, eqnVals);
      this.verifyEqual(size(funcs), [1 2]);
      this.verifyTrue(isscalar(funcs{1}([3])));
      this.verifyTrue(isscalar(funcs{2}([3])));
    end

    function testModelFunctions2_Values3d(this)
      gridData.Grids = { 1:10 };
      eqnVals = reshape(1:30, [3 10]);
      funcs = ModelFunctions2(@GenericSpline, gridData, eqnVals);
      this.verifyEqual(size(funcs), [1 3]);
      this.verifyTrue(isscalar(funcs{1}([3])));
      this.verifyTrue(isscalar(funcs{2}([3])));
      this.verifyTrue(isscalar(funcs{3}([3])));
    end

  end

end
