%%% Monte Carlo Dynamic Classifier tool - MCDC tool

% Copyright (C) 2014 Gareth W. Peters, Tomoko Matsui, Francois Septier, and Akira Tamamori

% This program is free software; you can redistribute it and/or modify it under the terms
% of the GNU General Public License as published by the Free Software Foundation; either
% version 2 of the License, or (at your option) any later version.

% This program is distributed in the hope that it will be useful, but WITHOUT ANY
% WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE.  See the GNU General Public License for more details.

% You should have received a copy of the GNU General Public License along with this
% program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
% Floor, Boston, MA 02110-1301 USA.

%
% SkewTDistributionTest.m
%
classdef SkewTDistributionTest < matlab.unittest.TestCase

  methods (Test)

    function testSkewTDistribution(testCase)
      dist = SkewTDistribution(3, 4, 5, 6);
      testCase.verifyEqual(dist.Nu, 3);
      testCase.verifyEqual(dist.Mu, 4);
      testCase.verifyEqual(dist.Sigma, 5);
      testCase.verifyEqual(dist.Gamma, 6);
    end

    function testSkewTDistributionMultiVariate(testCase)
      dist = SkewTDistribution(3, [4 5], [6 7; 8 9], [10 11], 2);
      testCase.verifyEqual(dist.Nu, 3);
      testCase.verifyEqual(dist.Mu, [4 5]);
      testCase.verifyEqual(dist.Sigma, [6 7; 8 9]);
      testCase.verifyEqual(dist.Gamma, [10 11]);
    end

    function testPdf(testCase)
      dist = SkewTDistribution(3, 0, 1, 5);
      actual = dist.Pdf(0);
      expected = 0;
      testCase.verifyEqual(actual, expected, 'RelTol', 1e-6);
    end

    function testPdfMultiVariate(testCase)
    end

    function testRandom(testCase)
    end

    function testRandomMultiVariate(testCase)
    end

  end

end
